/*
    Copyright (C) 2012 Bartosz Broda, Jacek Bochenek, Łukasz Biłeńkij, 
    Damian Jaworski, Wojciech Mazur, Dominik Piasecki, Maciej Piasecki, 
    Radosław Ramocki
    
    This program is free software; you can redistribute it and/or modify it
under the terms of the GNU Lesser General Public License as published by the Free
Software Foundation; either version 3 of the License, or (at your option)
any later version.

    This program is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE. 

    See the LICENSE and COPYING files for more details.
*/

#include "filesimfunction.h"
namespace smartcomparator
{
	namespace simfunctions
	{
		FileSimFunction::FileSimFunction(Matrices::SuperMatrixPtr m, std::string sim_matrix) : SimilarityFunction(m)
		{
			simMatrix = Matrices::IO::ReadCRSFromSingleFile(sim_matrix,"simMatrix");
		}
		double FileSimFunction::CountSimilarity(Matrices::CompressedVector& v1, Matrices::CompressedVector& v2,
			size_t v1_index, size_t v2_index, const std::set<size_t> &v1Ind, const std::set<size_t> &v2Ind)
		{
			return simMatrix->GetCell(v1_index,v2_index);
		}

		bool FileSimFunction::IsSymmetrical() const
		{
			return false;
		}
		double FileSimFunction::MinValue() const
		{
			return -1;
		}

	}
}
